/*****************************/
/* kChat v1.7		     */
/* krzak@linux.net.pl        */ 
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.awt.event.*;
import java.awt.*;
import java.lang.*;
import java.util.Vector;

public class MsgFloatingWindow extends Frame implements WindowListener, ActionListener {
    public String nick = "";
    public String title = "";
    public Frame  fr = null;
    public TextArea text = null;
    public TextField input = null;

    MsgFloatingWindow(String title, String nick) {     // konstructor
	super("MsgFloatingWindow");
	this.title = title;
	this.nick  = nick;
	this.fr = new Frame(title);
	this.fr.setSize(400,250);
	this.fr.addWindowListener(this);

	this.text = new TextArea("",10,10,TextArea.SCROLLBARS_VERTICAL_ONLY);
	this.text.setEditable(false);
        this.text.setBackground(new Color(117,203,252));

	this.input = new TextField("",10); 
	this.input.setFont(new Font("fixed", 0, 12));
	this.input.addActionListener(this);

	Panel panel = new Panel(new BorderLayout());
	panel.add(this.text,BorderLayout.CENTER);
	panel.add(this.input,BorderLayout.SOUTH);
	
	this.fr.add(panel);	

	// dodaje do listy nikow
	WindowChat tmp = new WindowChat(); 
	tmp.nick = nick; 
	tmp.window = this;
	kChatApplet.windowsList.addElement(tmp);
    };
    


    public void setVisible(boolean state) {
    if (this.fr != null) this.fr.setVisible(state);
    }
    

    // ***********
    // WINDOW
    // ***********
    public void windowClosing(WindowEvent e) {
	WindowChat tmpW = new WindowChat();
	for (int i=0; i < kChatApplet.windowsList.size(); i++){
	    tmpW = (WindowChat)kChatApplet.windowsList.elementAt(i);
	    if (tmpW.nick.equals(nick)) kChatApplet.windowsList.removeElementAt(i);
	    }
	this.fr.dispose();
    }
		
    public void windowClosed(WindowEvent e) { }
    public void windowOpened(WindowEvent e) { }
    public void windowIconified(WindowEvent e) { }
    public void windowDeiconified(WindowEvent e) { }

    public void windowActivated(WindowEvent e) {
	for (int i = 0; i < kChatApplet.nList.getItemCount();i++)
	    if (kChatApplet.nList.getItem(i).equals(this.nick)) kChatApplet.nList.select(i);
    }
													
    public void windowDeactivated(WindowEvent e) {
	for (int i = 0; i < kChatApplet.nList.getItemCount();i++)
	    if (kChatApplet.nList.getItem(i).equals(this.nick)) kChatApplet.nList.deselect(i);
    }

    
    // ***********
    // INPUT
    // ***********
      public void actionPerformed(ActionEvent e) {
	kChatApplet.net.send("*MSG|"+ kChatApplet.login + "|"+ this.nick + "|" + e.getActionCommand()+"|black|");
	String s = "<" + kChatApplet.login + "> " + e.getActionCommand()+"\n";
	this.text.append(s);
	this.input.setText("");
	this.text.setCaretPosition((this.text.getText()).length());
      }
    
}
