/*****************************/
/* kChat v1.7		     */
/* krzak@linux.net.pl        */ 
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.awt.*;
import java.awt.event.*;

public class kChatActions implements ActionListener, ItemListener, WindowListener {
    private Dialog    passDialog = null;
    private TextField passInput  = null;
    private TextField guestInput = null;
    public Frame moderToClose = null;

    public void actionPerformed(ActionEvent e) {
	/* LOGOUT */
	if (e.getActionCommand().equals("LOGOUT")) {
	    kChatApplet.net.send("*CLOSE");
	    kChatApplet.chanWnd.appendText("Zostales wylogowany","black");
	}
	/* PRIVATE */
	if (e.getActionCommand().equals("PRIVATE")) {
	if ((!(kChatApplet.login.equals(kChatApplet.selectedNick))) && 
	    (!(kChatApplet.selectedNick.equals(""))) &&
	   (kChatApplet.alreadyExistNick(kChatApplet.selectedNick) == false)) {
	    MsgFloatingWindow fw = new MsgFloatingWindow("Gadatka z " + kChatApplet.selectedNick,kChatApplet.selectedNick);
	    fw.setVisible(true);
	   }
	}
	/* MODERATOR */
	if (e.getActionCommand().equals("MODERATOR")) {
	passDialog = new Dialog(new Frame(),"Haslo",true);
	passInput = new TextField("password",20);
	guestInput = new TextField("guest",20);
	
	Button passOK = new Button("OK");
	passOK.setActionCommand("PASSOK");
	passOK.addActionListener(this);

	passDialog.add(passInput,BorderLayout.NORTH);
	passDialog.add(guestInput,BorderLayout.CENTER);
	passDialog.add(passOK,BorderLayout.SOUTH);
	passDialog.addWindowListener(this);
	passDialog.show();
	}
	
	/* PASSOK */
	if (e.getActionCommand().equals("PASSOK")) {
	if ( (passInput != null) && (guestInput != null) &&
	   (!passInput.getText().equals("")) && (!guestInput.getText().equals("")) ) { 
	   kChatApplet.net.send("*MODERATOR|" + passInput.getText() + "|" + guestInput.getText() + "|");
	   passDialog.dispose();
	   }
	}

	/* CLOSEMODER */
	if (e.getActionCommand().equals("CLOSEMODER")) {
	   if (moderToClose != null) { 
		kChatApplet.net.send("*NOMODERATOR");
		moderToClose.dispose();
		moderToClose = null;
	   } 
	}

    }
    
    public void itemStateChanged(ItemEvent e) {
	if (e.getStateChange() == ItemEvent.SELECTED) 
	    { kChatApplet.selectedNick = kChatApplet.nList.getSelectedItem(); }
    }

    public void windowClosing(WindowEvent e) {  e.getWindow().dispose(); }
    public void windowClosed(WindowEvent e) {  }
    public void windowOpened(WindowEvent e) {  }
    public void windowIconified(WindowEvent e) { }
    public void windowDeiconified(WindowEvent e) { }
    public void windowActivated(WindowEvent e) { }
    public void windowDeactivated(WindowEvent e) { }

    
}