/*****************************/
/* kChat v1.7		     */
/* krzak@linux.net.pl        */ 
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* Last update: 14 X 2001 22:33:26 CEST */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.net.*;
import java.util.Vector;

public class kChatApplet extends Applet implements AdjustmentListener, KeyListener {
  public static int sizeX = 600;
  public static int sizeY = 470;
  public static kChatNet net = null;
  public static String login = "any";
  public static kChatChannel chanWnd = null;
  public static kChatChannel chanWndModer = null;
  public static Scrollbar sbar = null;
  public static Scrollbar msbar = null;
  public static TextArea input = null;
  public static String msgColor = "black";
  public static List nList = null;
  public static boolean moderate = false;
  public static Image bgImage = null;
  public static Image bgImageModer = null;
  public static String moderatorNick = "";
  public static String selectedNick = "";
  public static Frame moderFr = null;
  public static Vector windowsList = new Vector();
  private static String host = new String();
  private static kChatActions actions = new kChatActions();

public void init() {

    try { 
    if (getParameter("background") != null) 
	bgImage = getImage(new URL(getParameter("background"))); 
    if (getParameter("backgroundmoder") != null) 
	bgImageModer = getImage(new URL(getParameter("backgroundmoder"))); 
    } catch (java.net.MalformedURLException e) { }

 setSize(sizeX, sizeY);
 setBackground(Color.white);

 chanWnd = new kChatChannel(sizeX-130,sizeY-60);
 chanWnd.setFont(new Font("",Font.PLAIN,12));
 chanWnd.setBackground(Color.white);
 chanWnd.setBackgroundImage(bgImage);

 sbar = new Scrollbar(Scrollbar.VERTICAL,0,1,0,100);    
 sbar.addAdjustmentListener(this);
 sbar.setSize(sbar.getSize().width,sizeY-150);

 chanWnd.setScroller(sbar);

 nList = new List(23);

// kChatActions  actions = new kChatActions();
 Button bLogout = new Button("WYLOGUJ"); 
 bLogout.setActionCommand("LOGOUT");
 bLogout.addActionListener(actions);
 Button bPrivate = new Button("PRYWATNIE");
 bPrivate.setActionCommand("PRIVATE");
 bPrivate.addActionListener(actions);
 Button bModerator = new Button("MODERATOR"); 
 bModerator.setActionCommand("MODERATOR");
 bModerator.addActionListener(actions);

 input = new TextArea("",2,50,TextArea.SCROLLBARS_VERTICAL_ONLY);
 input.setSize(100,50);
 input.setFont(new Font("",Font.PLAIN,12));
 input.addKeyListener(this);

 Panel panel = new Panel(new BorderLayout()); 
 Panel leftP = new Panel(new BorderLayout());
 Panel downP = new Panel(new BorderLayout());
 Panel rightP = new Panel(new BorderLayout());
 Panel buttonsP = new Panel(new BorderLayout());
 
 buttonsP.add(bLogout,BorderLayout.NORTH);
 buttonsP.add(bPrivate, BorderLayout.CENTER);
 buttonsP.add(bModerator, BorderLayout.SOUTH);

 rightP.add(nList, BorderLayout.NORTH);
 rightP.add(buttonsP, BorderLayout.SOUTH);

 leftP.add(chanWnd, BorderLayout.WEST);
 leftP.add(sbar, BorderLayout.CENTER);
 leftP.add(rightP, BorderLayout.EAST);

 downP.add(input, BorderLayout.CENTER);

 panel.add(leftP, BorderLayout.CENTER);
 panel.add(downP, BorderLayout.SOUTH);

 add(panel);

 msbar = new Scrollbar(Scrollbar.VERTICAL,0,1,0,100);    
 msbar.addAdjustmentListener(this);
 msbar.setSize(msbar.getSize().width,sizeY);

 nList.addItemListener(actions);

 msgColor = getParameter("color");
 net = new kChatNet();
 net.connect(getCodeBase().getHost());
 host = getCodeBase().getHost();
 net.send("*LOGIN|SYSTEM|"+getParameter("login")+"|"+ getParameter("pass") +"|");
 net.send("*CHECK");
}


public static void moderWinOpen() {
 Panel panel = new Panel(new BorderLayout());
 Panel pwm = new Panel(new BorderLayout());

 moderFr = new Frame("Moderacja kanalem");
 moderFr.setSize(sizeX-108,sizeY-18+30);
 moderFr.setResizable(true);
 moderFr.setLayout(new BorderLayout());
// moderFr.addWindowListener(actions);


 chanWndModer = new kChatChannel(sizeX-130,sizeY-60);
 chanWndModer.setFont(new Font("",Font.PLAIN,12));
 chanWndModer.setScroller(msbar);
 chanWndModer.setBackgroundImage(bgImageModer);

 pwm.add(chanWndModer,BorderLayout.WEST);
 pwm.add(msbar, BorderLayout.EAST);
 
 actions.moderToClose=moderFr;
 Button bClose = new Button("ZAMKNIJ");
 bClose.setActionCommand("CLOSEMODER");
 bClose.addActionListener(actions);

 panel.add(pwm,BorderLayout.NORTH);
 panel.add(bClose,BorderLayout.CENTER);
 
 moderFr.add(panel);
 moderFr.setVisible(true);
}


public void adjustmentValueChanged(AdjustmentEvent e) {
 if (e.getAdjustable() == sbar) chanWnd.moveStart(e.getValue());
 if (e.getAdjustable() == msbar) chanWndModer.moveStart(e.getValue());
}

public void keyTyped(KeyEvent e) { }
public void keyPressed(KeyEvent e) {
	if ((e.getKeyCode() == KeyEvent.VK_ENTER) 
&& (input.getText().length()>0) && (!input.getText().equals(""))) { 
		  boolean kick = false;
		  if (input.getText().startsWith("/K"))
		    {
		    String val = input.getText().substring(3,input.getText().length());
		    input.setText(""); 
		    input.setCaretPosition(0);
		    val.trim();
		    net.send("*KICK|"+val+"|");
		    kick = true;
		    }
		    if (!kick)
		     if ((moderate) && (login.equals(moderatorNick)))
			net.send("*MSG|" + login + "|CHAN|Moderator : " + input.getText().replace('|',':') + "|" + msgColor + "|"); 
			else
			net.send("*MSG|" + login + "|CHAN|" + input.getText().replace('|',':') + "|" + msgColor + "|"); 
		}
}
	
public void keyReleased(KeyEvent e) 
{
	if ((e.getKeyCode() == KeyEvent.VK_ENTER) 
&& (input.getText().length()>0) && (!input.getText().equals(""))) {
		input.setText(""); 
		
input.setCaretPosition(0); 
		}
}

public static boolean alreadyExistNick(String nick) {
	WindowChat tmpW = new WindowChat();
	for (int i=0; i < windowsList.size(); i++){
	    tmpW = (WindowChat)windowsList.elementAt(i);
	    if (tmpW.nick.equals(nick)) return(true);
	    }
 return(false);
}


public static MsgFloatingWindow getMsgWindowFromList(String nick) {
	WindowChat tmpW = new WindowChat();
	for (int i=0; i < windowsList.size(); i++){
	    tmpW = (WindowChat)windowsList.elementAt(i);
	    if (tmpW.nick.equals(nick)) return(tmpW.window);
	    }
 return(null);
}

public synchronized void destroy() { 
    net.send("*CLOSE"); 
    net.disconnect(); 
}

public void update(Graphics g) { paint(g); }
public void start(Graphics g) { repaint(); }
public void stop(Graphics g) { repaint(); }
public void paint(Graphics g) { super.paint(g); }


}
