/*****************************/
/* kChat v1.7		     */
/* krzak@linux.net.pl        */ 
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.net.*;
import java.io.*;

public class kChatServerThread extends Thread
{
    Socket	   clientS = null;
    BufferedReader br = null;
    PrintWriter    pw = null;
    String  	   login     = "";
    int		   ping = 0;

    public kChatServerThread(Socket cl)
    {
    super("kChatServerThread");
    this.clientS = cl;
    }

    public void run()
    {
    try {
	br = new BufferedReader(new InputStreamReader(clientS.getInputStream()));
	pw = new PrintWriter(new BufferedOutputStream(clientS.getOutputStream(), 1024), false);
	pw.println("WELCOME " + clientS.getInetAddress().getHostAddress()+"\r\n");
	pw.flush();
	
	String liniaWe, liniaWy;
	liniaWy = "";
	while ((liniaWe = br.readLine()) != null) 
	    {
	    liniaWy = kChatSystem.getAnswerFor(liniaWe,this);
    	    if (!liniaWy.equals("")) {
	         pw.println(liniaWy+"\r\n");
	         pw.flush();
        	 }
	    if (liniaWy.equals("BYE")) break;
	    }

	br.close();
	pw.close();
	if ((liniaWy == null) || (!liniaWy.equals("BYE")))
		kChatSystem.quitFromSystem(login);
	clientS.close();
	} 
catch (IOException e) 
	    { 
	    kChatSystem.quitFromSystem(login);
	    e.printStackTrace(); 
	    }
    }
    
}